"""
Run this script using:

    blender -b --python same_pose_renderer_all.py 
    
"""

import argparse
import numpy as np
import os
import sys
sys.path.append(os.path.dirname(__file__))

import util
import blender_interface
import time 

img_dir = '/home/wang_c/Downloads/SRN_part'
output_dir = '/home/wang_c/Downloads/buffer2'
obj_dir = '/home/wang_c/Downloads/shapenet_part'


def get_subdirectories(base_dir, directory=True):
    subdirectories = [os.path.join(base_dir, d) for d in os.listdir(base_dir) if (not directory) or os.path.isdir(os.path.join(base_dir, d))]
    return subdirectories

# 1. save pose 
# 2. save original image 
# 3. save new rendered image 

def save_pose(choosed_poses):
    for i in choosed_poses:
        saved_location = os.path.join(*i.split('/')[-3:-1])
        saved_location = os.path.join(output_dir, saved_location)
        if not os.path.exists(saved_location):
            os.makedirs(saved_location)
        os.system(f"cp {i} {saved_location}")
        
def save_img(choosed_poses):
    for i in choosed_poses:
        base_dir = os.path.join(*i.split('/')[:-2], 'rgb')
        item_num = i.split('/')[-1].split('.')[0]
        img = os.path.join(base_dir, item_num + ".png")
        saved_location = os.path.join(*img.split('/')[-3:-1])
        saved_location = os.path.join(output_dir, saved_location)
        if not os.path.exists(saved_location):
            os.makedirs(saved_location)
        os.system(f"cp /{img} {saved_location}")
        
def get_obj_path(obj):
    obj_name = obj.split('/')[-1]
    return os.path.join(obj_dir, obj_name, "models/model_normalized.obj")

def save_obj(pose_path, obj_path):
    parent_dir = os.path.join(output_dir, pose_path.split('/')[-3])
    save_path = os.path.join(parent_dir, "new_rendered")
    temp_save_path = os.path.join(save_path, "buffer")
    
    # Create new_rendered folder if it doesn't exist
    if not os.path.exists(save_path):
        os.makedirs(save_path)
    
    # Create mask and depth folders if they don't exist
    mask_path = os.path.join(parent_dir, 'mask')
    depth_path = os.path.join(parent_dir, 'depth')
    
    if not os.path.exists(mask_path):
        os.makedirs(mask_path)
    if not os.path.exists(depth_path):
        os.makedirs(depth_path)
        
    original_rgb_path = os.path.join(temp_save_path, "rgb/000000.png")
    original_mask_path = os.path.join(temp_save_path, "mask/000000.png")
    original_depth_path = os.path.join(temp_save_path, "depth/000000.png")
    
    png_name = (pose_path.split('/')[-1]).split('.')[0]
    new_rgb_path = os.path.join(save_path, f"{png_name}.png")
    new_mask_path = os.path.join(mask_path, f"{png_name}.png")
    new_depth_path = os.path.join(depth_path, f"{png_name}.png")
    
    # Render pipeline
    # (Note: You'll need to modify your render function to save mask and depth images as well.)
    renderer = blender_interface.BlenderInterface(resolution=128)
    obj_location = np.zeros((1,3))
    cam_pose = util.read_pose(pose_path)
    blender_poses = [util.cv_cam2world_to_bcam2world(cam_pose)]
    obj_pose = None#np.eye(4)
    renderer.import_mesh(obj_path, scale=1., object_world_matrix=obj_pose)
    renderer.render(temp_save_path, blender_poses, write_cam_params=True)
    
    # Move the files
    os.system(f"mv {original_rgb_path} {new_rgb_path}")
    
    # Assuming the mask and depth images are generated by your renderer
    os.system(f"mv {original_mask_path} {new_mask_path}")
    os.system(f"mv {original_depth_path} {new_depth_path}")
    
    # Clean up
    os.system(f"rm -rf {temp_save_path}")
  
# starting time 
st = time.time()
    
os.system(f"rm -rf {output_dir}")
os.mkdir(output_dir)     

objects = sorted(get_subdirectories(img_dir))

for obj in objects: 
    pose_path = os.path.join(obj, 'pose')
    poses = sorted(get_subdirectories(pose_path, directory=False))
    save_img(poses)
    save_pose(poses)
    obj_path = get_obj_path(obj)
    for pose_path in poses:
        save_obj(pose_path, obj_path)

print("Total time:", time.time() - st)